ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.21 by root, Mon Dec 13 18:08:01 2010 UTC vs.
Revision 1.40 by root, Sun May 1 07:56:26 2011 UTC

7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc 13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
21 i*86 | x86_64 | amd64 ) 21 i*86 | x86_64 | amd64 )
22 #PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 22 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
23 PERL_OPTIMIZE="$PERL_OPTIMIZE" # x86/amd64
24 case "$ARCH" in 23 case "$ARCH" in
25 i*86 ) 24 i*86 )
26 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
27 ;; 26 ;;
28 esac 27 esac
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 37
38# some configuration options for modules 38# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
42 44
43# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
44# required by mkbundle 46# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 48
47# which extra modules you might want to install 49# which extra modules you might want to install
48EXTRA_MODULES="" 50EXTRA_MODULES=""
49 51
50# overridable functions 52# overridable functions
51preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
52postconfigure() { : ; } 55postconfigure() { : ; }
53postbuild() { : ; } 56postbuild() { : ; }
54postinstall() { : ; } 57postinstall() { : ; }
55 58
56# now source user config, if any 59# now source user config, if any
63fi 66fi
64 67
65############################################################################# 68#############################################################################
66# support 69# support
67 70
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70 72
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
72export LC_ALL=C # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
73 80
74# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
75VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
76$VERSION=0.911 83$VERSION="1.21"
77 84
78BZ2=bz2 85BZ2=bz2
79BZIP2=bzip2 86BZIP2=bzip2
80 87
81fatal() { 88fatal() {
127 134
128clean() { 135clean() {
129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130} 137}
131 138
139realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
143}
144
132fetch() { 145fetch() {
133 rcd "$STATICPERL" 146 rcd "$STATICPERL"
134 147
135 mkdir -p src 148 mkdir -p src
136 rcd src 149 rcd src
146perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
147trying $URL 160trying $URL
148EOF 161EOF
149 162
150 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
151 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
152 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
153 || fatal "$URL: unable to download" 166 || fatal "$URL: unable to download"
154 rm -f perl-$PERL_VERSION.tar.$BZ2 167 rm -f perl-$PERL_VERSION.tar.$BZ2
155 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
156 fi 169 fi
157 170
159unpacking perl 172unpacking perl
160EOF 173EOF
161 174
162 mkdir -p unpack 175 mkdir -p unpack
163 rm -rf unpack/perl-$PERL_VERSION 176 rm -rf unpack/perl-$PERL_VERSION
164 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
165 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
166 chmod -R u+w unpack/perl-$PERL_VERSION 179 chmod -R u+w unpack/perl-$PERL_VERSION
167 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
168 rmdir -p unpack 181 rmdir -p unpack
169 fi 182 fi
170} 183}
174 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 187 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
175 rm -f "$2" 188 rm -f "$2"
176 mv "$2~" "$2" 189 mv "$2~" "$2"
177} 190}
178 191
192configure_failure() {
193 cat <<EOF
194
195
196***
197*** Configure failed - see above for the exact error message(s).
198***
199*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
200*** flags are not supported by your compiler. Less often, this is because
201*** PERL_LIBS either contains a library not available on your system (such as
202*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
203***
204*** You can provide your own flags by creating a ~/.staticperlrc file with
205*** variable assignments. For example (these are the actual values used):
206***
207
208PERL_CC="$PERL_CC"
209PERL_CCFLAGS="$PERL_CCFLAGS"
210PERL_OPTIMIZE="$PERL_OPTIMIZE"
211PERL_LDFLAGS="$PERL_LDFLAGS"
212PERL_LIBS="$PERL_LIBS"
213
214EOF
215 exit 1
216}
217
179configure() { 218configure() {
180 fetch 219 fetch
181 220
182 rcd "$STATICPERL/src/perl-$PERL_VERSION" 221 rcd "$STATICPERL/src/perl-$PERL_VERSION"
183 222
189 228
190 rm -f "$PERL_PREFIX/staticstamp.install" 229 rm -f "$PERL_PREFIX/staticstamp.install"
191 230
192 "$MAKE" distclean >/dev/null 2>&1 231 "$MAKE" distclean >/dev/null 2>&1
193 232
233 sedreplace '/^#define SITELIB/d' config_h.SH
234
194 # I hate them 235 # I hate them for this
195 grep -q -- -fstack-protector Configure && \ 236 grep -q -- -fstack-protector Configure && \
196 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
197 238
198 preconfigure 239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
199 244
200# trace configure \ 245# trace configure \
201 sh Configure -Duselargefiles \ 246 sh Configure -Duselargefiles \
202 -Uuse64bitint \ 247 -Uuse64bitint \
203 -Dusemymalloc=n \ 248 -Dusemymalloc=n \
205 -Uusethreads \ 250 -Uusethreads \
206 -Uuseithreads \ 251 -Uuseithreads \
207 -Uusemultiplicity \ 252 -Uusemultiplicity \
208 -Uusesfio \ 253 -Uusesfio \
209 -Uuseshrplib \ 254 -Uuseshrplib \
255 -Uinstallusrbinperl \
256 -A ccflags=" $PERL_CCFLAGS" \
210 -Dcc="$PERL_CC" \ 257 -Dcc="$PERL_CC" \
211 -Dcppflags="$PERL_CPPFLAGS" \
212 -Dccflags="-g2 -fno-strict-aliasing" \
213 -Doptimize="$PERL_OPTIMIZE" \ 258 -Doptimize="$PERL_OPTIMIZE" \
214 -Dldflags="$PERL_LDFLAGS" \ 259 -Dldflags="$PERL_LDFLAGS" \
215 -Dlibs="$PERL_LIBS" \ 260 -Dlibs="$PERL_LIBS" \
216 -Dprefix="$PERL_PREFIX" \ 261 -Dprefix="$PERL_PREFIX" \
217 -Dbin="$PERL_PREFIX/bin" \ 262 -Dbin="$PERL_PREFIX/bin" \
218 -Dprivlib="$PERL_PREFIX/lib" \ 263 -Dprivlib="$PERL_PREFIX/lib" \
219 -Darchlib="$PERL_PREFIX/lib" \ 264 -Darchlib="$PERL_PREFIX/lib" \
220 -Uusevendorprefix \ 265 -Uusevendorprefix \
221 -Dsitelib="$PERL_PREFIX/lib" \ 266 -Dsitelib="$PERL_PREFIX/lib" \
222 -Dsitearch="$PERL_PREFIX/lib" \ 267 -Dsitearch="$PERL_PREFIX/lib" \
223 -Usitelibexp \
224 -Uman1dir \ 268 -Uman1dir \
225 -Uman3dir \ 269 -Uman3dir \
226 -Usiteman1dir \ 270 -Usiteman1dir \
227 -Usiteman3dir \ 271 -Usiteman3dir \
228 -Dpager=/usr/bin/less \ 272 -Dpager=/usr/bin/less \
229 -Demail="$EMAIL" \ 273 -Demail="$EMAIL" \
230 -Dcf_email="$EMAIL" \ 274 -Dcf_email="$EMAIL" \
231 -Dcf_by="$EMAIL" \ 275 -Dcf_by="$EMAIL" \
232 $PERL_CONFIGURE \ 276 $PERL_CONFIGURE \
233 -Duseperlio \ 277 -Duseperlio \
234 -dE || fatal "Configure failed" 278 -dE || configure_failure
235 279
236 sedreplace ' 280 sedreplace '
237 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
238 s/ *-fno-stack-protector */ /g 282 s/ *-fno-stack-protector */ /g
239 ' config.sh 283 ' config.sh
240 284
285 patchconfig || fatal "patchconfig hook failed"
286
241 sh Configure -S || fatal "Configure -S failed" 287 sh Configure -S || fatal "Configure -S failed"
242 288
243 postconfigure || fatal "postconfigure hook failed" 289 postconfigure || fatal "postconfigure hook failed"
244 290
245 touch staticstamp.configure 291 touch staticstamp.configure
292}
293
294write_shellscript() {
295 {
296 echo "#!/bin/sh"
297 echo "STATICPERL=\"$STATICPERL\""
298 echo "PERL_PREFIX=\"$PERL_PREFIX\""
299 echo "MAKE=\"$MAKE\""
300 cat
301 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1"
246} 303}
247 304
248build() { 305build() {
249 configure 306 configure
250 307
271EOF 328EOF
272 329
273 ln -sf "perl/bin/" "$STATICPERL/bin" 330 ln -sf "perl/bin/" "$STATICPERL/bin"
274 ln -sf "perl/lib/" "$STATICPERL/lib" 331 ln -sf "perl/lib/" "$STATICPERL/lib"
275 332
333 mkdir "$STATICPERL/patched"
334
276 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
277 rm -rf "$PERL_PREFIX" # by this rm -rf 336 rm -rf "$PERL_PREFIX" # by this rm -rf
278 337
279 "$MAKE" install || fatal "make install: error while installing" 338 "$MAKE" install || fatal "make install: error while installing"
280 339
281 rcd "$PERL_PREFIX" 340 rcd "$PERL_PREFIX"
282 341
283 # create a "make install" replacement for CPAN 342 # create a "make install" replacement for CPAN
284 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 343 write_shellscript SP-make-install-make <<'EOF'
285"$MAKE" || exit 344#CAT make-install-make.sh
286
287if find blib/arch/auto -type f | grep -q -v .exists; then
288 echo Probably an XS module, rebuilding perl
289 if "$MAKE" perl; then
290 mv perl "$PERL_PREFIX"/bin/perl~ \
291 && rm -f "$PERL_PREFIX"/bin/perl \
292 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
293 "$MAKE" -f Makefile.aperl map_clean
294 else
295 "$MAKE" -f Makefile.aperl map_clean
296 exit 1
297 fi
298fi
299
300"$MAKE" install UNINST=1
301EOF 345EOF
302 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
303 346
347 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF'
349#CAT patch-postinstall.sh
350EOF
351
352 "$PERL_PREFIX/bin/SP-patch-postinstall"
353
304 # trick CPAN into avoiding ~/.cpan completely 354 # help to trick CPAN into avoiding ~/.cpan completely
305 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
306 356
357 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway,
359 # so consider it "for good measure".
307 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
308 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
309 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
310 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
311 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
312 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
313 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
314 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
315 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
316 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
317 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
318 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
319 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
320 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
321 375
322 touch "$PERL_PREFIX/staticstamp.install" 376 touch "$PERL_PREFIX/staticstamp.install"
323 fi 377 fi
343installing modules from CPAN 397installing modules from CPAN
344$@ 398$@
345EOF 399EOF
346 400
347 for mod in "$@"; do 401 for mod in "$@"; do
348 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
349 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
350 done 404 done
351 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
352} 406}
353 407
369 rcd $mod 423 rcd $mod
370 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
371 "$MAKE" distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
372 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
373 "$MAKE" || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
374 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
375 "$MAKE" distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
376 exit 0 430 exit 0
377 ) || exit $? 431 ) || exit $?
378 done 432 done
379} 433}
411#CAT mkbundle 465#CAT mkbundle
412MKBUNDLE 466MKBUNDLE
413} 467}
414 468
415bundle() { 469bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
416 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
417 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 472 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
418 CACHE="$STATICPERL/cache" 473 CACHE="$STATICPERL/cache"
419 mkdir -p "$CACHE" 474 mkdir -p "$CACHE"
420 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 475 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
428 command="${1#--}"; shift 483 command="${1#--}"; shift
429 case "$command" in 484 case "$command" in
430 version ) 485 version )
431 echo "staticperl version $VERSION" 486 echo "staticperl version $VERSION"
432 ;; 487 ;;
433 fetch | configure | build | install | clean | distclean) 488 fetch | configure | build | install | clean | realclean | distclean)
434 ( "$command" ) 489 ( "$command" ) || exit
435 ;; 490 ;;
436 instsrc ) 491 instsrc )
437 ( instsrc "$@" ) 492 ( instsrc "$@" ) || exit
438 exit 493 exit
439 ;; 494 ;;
440 instcpan ) 495 instcpan )
441 ( instcpan "$@" ) 496 ( instcpan "$@" ) || exit
497 exit
498 ;;
499 perl )
500 ( install ) || exit
501 exec "$PERL_PREFIX/bin/perl" "$@"
442 exit 502 exit
443 ;; 503 ;;
444 cpan ) 504 cpan )
445 ( install ) 505 ( install ) || exit
446 "$PERL_PREFIX/bin/cpan" "$@" 506 exec "$PERL_PREFIX/bin/cpan" "$@"
447 exit 507 exit
448 ;; 508 ;;
449 mkbundle ) 509 mkbundle )
450 ( install ) 510 ( install ) || exit
451 bundle "$@" 511 bundle "$@"
452 exit 512 exit
453 ;; 513 ;;
454 mkperl ) 514 mkperl )
455 ( install ) 515 ( install ) || exit
456 bundle --perl "$@" 516 bundle --perl "$@"
457 exit 517 exit
458 ;; 518 ;;
459 mkapp ) 519 mkapp )
460 ( install ) 520 ( install ) || exit
461 bundle --app "$@" 521 bundle --app "$@"
462 exit 522 exit
463 ;; 523 ;;
464 help ) 524 help )
465 podusage 2 525 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines